<!--
 * @Title: 
 * @Description: 
 * @Author: swp
 * @Date: 2022-08-24 10:49:21
 * @LastEditors: 
 * @LastEditTime: 2022-08-24 10:49:21
-->
<template>
    <div>
    <el-row>
        <!-- <el-col :span="5">
        <div class="box">
          <el-scrollbar>
          <basic-container>
            <avue-tree
                  :option="treeOption"
                  :data="treeData"
                  @node-click="nodeClick"
                />
              </basic-container>
            </el-scrollbar>
            </div>
          </el-col> -->
            <el-col :span="24">
                <basic-container>
                    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page"
                        :before-open="beforeOpen" ref="crud" v-model="form" :permission="permissionList" @row-del="rowDel"
                        @row-update="rowUpdate" @row-save="rowSave" @search-change="searchChange"
                        @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
                        @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad"
                        @before-open="beforeOpen">
                        <template slot="state" slot-scope="{ row }">
                        <el-button type="text" @click="openConfig(row)"> 正常 </el-button>
                        </template>
                        <template slot-scope="{ row, index }" slot="menu">

                            <el-button type="text" size="small" @click="warnSetting(row)">预警配置
                            </el-button>

                            <!-- <el-button type="text" size="small" @click="planManage(row)">巡检计划
                </el-button> -->

                        </template>
                    </avue-crud>
                </basic-container>
            </el-col>
        </el-row>
        <el-dialog title="预警配置" :visible.sync="warnSettingDialog" v-if="warnSettingDialog" width="600px"
            :before-close="handleClose" :close-on-click-modal="false" append-to-body>
            <el-form label-width="120px">
                <el-form-item label="预警总开关">
                    <el-switch v-model="warningConfig.configSw" active-color="#13ce66" inactive-color="#ff4949"
                        active-text="开" inactive-text="关">
                    </el-switch>
                </el-form-item>
                <el-form-item label="延时配置">
                    <el-input placeholder="请输入延时时长" v-model="warningConfig.delayTime">
                        <template slot="append">单位分钟</template>
                    </el-input>
                </el-form-item>
                <el-form-item label="">
                    <label>延时时长用于测站离线预警监测，当超过配置的时长时触发预警,默认2小时</label>
                </el-form-item>
        </el-form>
        <span slot="footer" class="dialog-footer">
            <el-button @click="warnSettingDialog = false" size="small">取 消</el-button>
            <el-button type="primary" @click="confirmConfigClick" size="small">确 定</el-button>
            </span>
        </el-dialog>

        <!-- <el-dialog title="巡检计划"  :visible.sync="projectPlanDialog" v-if="projectPlanDialog" width="60%" height="60%" :close-on-click-modal="false"
        append-to-body>
        <projectPlan :planSetting="planSetting"  
          ref="projectPlan"></projectPlan>
      </el-dialog> -->


    </div>
</template>

<script>
import { getPage, getDetail, add, update, remove, warnSetting } from "@/api/baseinfo/project";

import {
    getDeptTree,
} from "@/api/system/dept.js";


export default {
    components: {

    },
    data() {
        return {

            projectPlanDialog: false,
            orderDialog: false,
            warningConfig: {
                id: '',
                configSw: true,
                delayTime: "120",
            },
            planSetting: {
                orgId: 0,
                projectId: 0,
                planTitle: ''
            },
            infoDialog: false,
            warnSettingDialog: false,
            id: "",
            editForm: {},
            editDialog: false,
            form: {},
            selectionList: [],
            query: {},
            loading: true,
            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            treeOption: {
                nodeKey: "id",
                lazy: true,
                treeLoad: function (node, resolve) {
                    const parentId = node.level === 0 ? 0 : node.data.id;
                    console.log(parentId)
                    console.log(resolve)
                    // getDeptLazyTree(parentId).then((res) => {
                    //   resolve(
                    //     res.data.data.map((item) => {
                    //       return {
                    //         ...item,
                    //         leaf: !item.hasChildren,
                    //       };
                    //     })
                    //   );
                    // });
                },
                addBtn: false,
                menu: false,
                size: "small",
                props: {
                    labelText: "标题",
                    label: "title",
                    value: "value",
                    children: "children",
                },
            },
            option: {
                labelWidth: 120,
                viewLabelWidth: 100,
                searchlabelWidth: 100,
                height: "auto",
                calcHeight: 80,
                align: "center",
                headerAlign: "center",
                lazy: true,
                tip: false,
                simplePage: true,
                searchShow: true,
                searchMenuSpan: 6,
                tree: true,
                border: true,
                index: true,
                selection: true,
                viewBtn: false,
                viewTitle: "项目信息",
                editBtn: true,
                delBtn: true,
                menuWidth: 220,
                dialogType: "drawer",
                dialogClickModal: false,
                column: [
                    {
                        label: "项目名称",
                        prop: "projectName",
                        search: true,
                        span: 12,
                    },
                    {
                        label: "所属机构",
                        prop: "orgId",
                        span: 12,
                        hide: true,
                        viewDisplay: false,


                        dicData: [],
                        type: "tree",

                        addDisabled: false,
                        props: {
                            label: "title",
                        },
                        rules: [
                            {
                                required: false,
                                message: "请选择机构",
                                trigger: "click",
                            },
                        ],
                    },
                    {
                        label: "所属机构",
                        prop: "orgName",
                        span: 12,
                        editDisplay: false,
                        addDisplay: false,
                    },
                    {
                        label: "开启预警",
                        prop: "warnActive",
                        span: 12,
                        editDisplay: false,
                        addDisplay: false,
                        dicData: [{
                            label: '已启预警',
                            value: 1,
                        }, {
                            label: '关闭',
                            value: 0,
                        }],
                    },
                    {
                        label: "管理人",
                        prop: "manageName",
                        span: 8,

                    },
                    {
                        label: "联系方式",
                        prop: "contactPhone",
                        span: 8,
                    },
                    {
                        label: "备注说明",
                        prop: "remark",
                        span: 24,
                        type: "textarea",

                    },
                ],
            },
            data: [],
        };
    },
    computed: {
        // ...mapGetters(["userInfo", "permission"]),
        permissionList() {
            return {
                // addBtn: this.vaildData(this.permission.docCategory_add, false),
                // viewBtn: this.vaildData(this.permission.docCategory_view, false),
                // delBtn: this.vaildData(this.permission.docCategory_delete, false),
                // editBtn: this.vaildData(this.permission.docCategory_edit, false),
            };
        },
        ids() {
            let ids = [];
            this.selectionList.forEach((ele) => {
                ids.push(ele.id);
            });
            return ids.join(",");
        },
    },
    mounted() { },
    created() {
        this.initData();
    },
    methods: {
        initData() {
            getDeptTree('000000').then((res) => {
                const column = this.findObject(this.option.column, "orgId");
                column.dicData = res.data.data;
            });
        },

        confirmConfigClick() {
            var p = {
                'id': this.warningConfig.id,
            };
            if (this.warningConfig.configSw) {
                p['warnActive'] = 1;
            } else {
                p['warnActive'] = 0;
            }
            p['delayTime'] = this.warningConfig.delayTime;

            this.warnSettingDialog = false;

            warnSetting(p).then(
                () => {

                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });

                },
                (error) => {
                    window.console.log(error);

                }
            );

        },
        warnSetting(item) {
            this.warningConfig.id = item.id;
            if (item.warnActive == 0) {
                this.warningConfig.configSw = false;
                this.warningConfig.delayTime = item.delayTime;
            } else {
                this.warningConfig.configSw = true;
                this.warningConfig.delayTime = item.delayTime;
            }

            this.warnSettingDialog = true;
        },
        planManage(item) {
            const planDate = new Date();
            this.planSetting.orgId = item.orgId;
            this.planSetting.projectId = item.id;
            const y = planDate.getFullYear();
            this.planSetting.planTitle = "" + y + "年" + item.orgName + "（" + item.projectName + "）巡检计划";
            this.projectPlanDialog = true;
        },
        // openInfo(item) {
        //   this.id = item.id;
        //   this.infoDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["warningInfo"].init();
        //   });
        // },
        // openOrder(item) {
        //   this.id = item.id;
        //   this.orderDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["maintainOrder"].init();
        //   });
        // },

        rowSave(row, done, loading) {
            add(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowUpdate(row, index, done, loading) {
            update(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowDel(row) {
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(row.id);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                });
        },
        searchReset() {
            this.query = {};
            this.onLoad(this.page);
        },
        searchChange(params, done) {
            this.query = params;
            this.page.currentPage = 1;
            this.onLoad(this.page, params);
            done();
        },
        selectionChange(list) {
            this.selectionList = list;
        },
        selectionClear() {
            this.selectionList = [];
            this.$refs.crud.toggleSelection();
        },
        handleDelete() {
            if (this.selectionList.length === 0) {
                this.$message.warning("请选择至少一条数据");
                return;
            }
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(this.ids);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    this.$refs.crud.toggleSelection();
                });
        },
        beforeOpen(done, type) {


            // if (["add", "edit"].includes(type)) {
            //     this.initData();
            //   }
            if (["edit", "view"].includes(type)) {
                getDetail(this.form.id).then((res) => {
                    this.form = res.data.data;
                });
            }
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        onLoad(page, params = {}) {
            this.loading = true;
            getPage(
                page.currentPage,
                page.pageSize,
                Object.assign(params, this.query)
            ).then((res) => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
                this.selectionClear();
            });
        },
    },
};
</script>
